From 6417bbc4409f9947a1a4f4fb3ac5479b195d2e25 Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 11/15] journal: Add support for not deduplicating specific fields in compact mode


For fields that are almost always unique, allocating a separate
Data object ends up adding a noticeable amount of overhead. By
adding support for storing these fields inline in the entry object,
we reduce the space required to store these unique fields.

If a field is marked as unique, we don't allocate a Data object and
store it inline in the Entry instead. The entry payload for storing
a single unique field has the following format:

- 1 byte for flags (compressed, etc)
- 4 bytes for size
- data (optionally compressed)

Each unique field is serialized to this format and the concatenation
of all the serialized unique fields becomes the entry payload.

When iterating over entries, we first iterate over all the deduplicated
fields via the trie. Once those are done, we continue with the inlined
fields. journal_file_entry_next()'s implementation is extended to support
this. One change in it's API is that ret_offset is set to zero for inline
fields if it is provided.

The list of fields to not deduplicate can be configured with the
$SYSTEMD_JOURNAL_UNIQUE_FIELDS environment variable. If it's not set, we
default to deduplicating all fields except MESSAGE.

With this change, we need to have the field object available before we
append the data object so we move field object allocation out of
journal_file_append_data() and into journal_file_append_entry() and
journal_file_copy_entry() instead.

Before:

OBJECT TYPE      ENTRIES  SIZE
Unused           0        0B
Data             3521895  587.0M
Field            3140     169.4K
Entry            3499118  240.2M
Data Hash Table  14       49.7M
Field Hash Table 14       73.0K
Entry Array	 577350   499.5M
Tag              0        0B
Trie Node        5767903  220.0M
Trie Hash Table  14       74.6M
Total            13369448 1.6G

After:

OBJECT TYPE      ENTRIES SIZE
Unused           0       0B
Data             1022925 95.3M
Field            2808    151.3K
Entry            3499976 667.7M
Data Hash Table  13      46.2M
Field Hash Table 13      67.8K
Entry Array      492907  576.7M
Tag              0       0B
Trie Node        1758648 67.0M
Trie Hash Table  13      69.3M
Total            6777303 1.4G

---

diff --git a/src/libsystemd/sd-journal/journal-def.h b/src/libsystemd/sd-journal/journal-def.h
index 7748998..d2bbb3c 100644
--- a/src/libsystemd/sd-journal/journal-def.h
+++ b/src/libsystemd/sd-journal/journal-def.h
@@ -47,11 +47,12 @@ typedef enum ObjectType {
 
 /* Object flags */
 enum {
-        OBJECT_COMPRESSED_XZ   = 1 << 0,
-        OBJECT_COMPRESSED_LZ4  = 1 << 1,
-        OBJECT_COMPRESSED_ZSTD = 1 << 2,
+        OBJECT_COMPRESSED_XZ    = 1 << 0,
+        OBJECT_COMPRESSED_LZ4   = 1 << 1,
+        OBJECT_COMPRESSED_ZSTD  = 1 << 2,
         OBJECT_COMPRESSION_MASK = (OBJECT_COMPRESSED_XZ | OBJECT_COMPRESSED_LZ4 | OBJECT_COMPRESSED_ZSTD),
-        _OBJECT_COMPRESSED_MAX = OBJECT_COMPRESSION_MASK,
+        FIELD_UNIQUE            = 1 << 3,
+        _OBJECT_COMPRESSED_MAX  = OBJECT_COMPRESSION_MASK,
 };
 
 struct ObjectHeader {
@@ -111,7 +112,10 @@ typedef struct {
         le64_t xor_hash;                       \
         union {                                \
                 EntryItem items[0];            \
-                le64_t trie_offset;            \
+                struct {                       \
+                        le64_t trie_offset;    \
+                        uint8_t payload[];     \
+                };                             \
         };                                     \
 }
 
diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index 87c6e50..bb7e942 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -34,6 +34,7 @@
 #include "string-util.h"
 #include "strv.h"
 #include "sync-util.h"
+#include "unaligned.h"
 #include "xattr-util.h"
 
 #define DEFAULT_DATA_HASH_TABLE_SIZE (2047ULL*sizeof(HashItem))
@@ -592,7 +593,7 @@ static int journal_file_move_to(
         return mmap_cache_fd_get(f->cache_fd, type_to_context(type), keep_always, offset, size, &f->last_stat, ret);
 }
 
-static uint64_t minimum_header_size(Object *o) {
+static uint64_t minimum_header_size(JournalFile *f, Object *o) {
 
         static const uint64_t table[] = {
                 [OBJECT_DATA] = sizeof(DataObject),
@@ -606,6 +607,10 @@ static uint64_t minimum_header_size(Object *o) {
                 [OBJECT_TRIE_HASH_TABLE] = sizeof(HashTableObject),
         };
 
+        if (o->object.type == OBJECT_ENTRY)
+                return JOURNAL_HEADER_COMPACT(f->header) ? offsetof(Object, entry.payload) :
+                                                           offsetof(Object, entry.items);
+
         if (o->object.type >= ELEMENTSOF(table) || table[o->object.type] <= 0)
                 return sizeof(ObjectHeader);
 
@@ -670,19 +675,13 @@ static int journal_file_check_object(JournalFile *f, uint64_t offset, Object *o)
 
                 sz = le64toh(READ_NOW(o->object.size));
                 if (JOURNAL_HEADER_COMPACT(f->header)) {
-                        if (sz != sizeof(EntryObject))
+                        if (sz < offsetof(Object, entry.payload))
                                 return log_debug_errno(
                                         SYNTHETIC_ERRNO(EBADMSG),
                                         "Bad entry size (<= %zu): %" PRIu64 ": %" PRIu64,
-                                        sizeof(EntryObject),
+                                        offsetof(Object, entry.payload),
                                         sz,
                                         offset);
-
-                        if (o->entry.trie_offset == 0)
-                                return log_debug_errno(
-                                        SYNTHETIC_ERRNO(EBADMSG),
-                                        "Bad entry trie offset (== 0): %" PRIu64,
-                                        offset);
                 } else {
                         if (sz < offsetof(EntryObject, items) ||
                             (sz - offsetof(EntryObject, items)) % sizeof(EntryItem) != 0)
@@ -841,7 +840,7 @@ int journal_file_move_to_object(JournalFile *f, ObjectType type, uint64_t offset
                                        "Attempt to move to object with invalid type: %" PRIu64,
                                        offset);
 
-        if (s < minimum_header_size(o))
+        if (s < minimum_header_size(f, o))
                 return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
                                        "Attempt to move to truncated object: %" PRIu64,
                                        offset);
@@ -906,7 +905,7 @@ int journal_file_read_object(JournalFile *f, ObjectType type, uint64_t offset, O
                                        "Attempt to read object with invalid type: %" PRIu64,
                                        offset);
 
-        if (s < minimum_header_size(&o))
+        if (s < minimum_header_size(f, &o))
                 return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
                                        "Attempt to read truncated object: %" PRIu64,
                                        offset);
@@ -1639,15 +1638,32 @@ static int journal_file_append_field(
         return 0;
 }
 
+static int maybe_compress_payload(JournalFile *f, uint8_t *dst, const uint8_t *src, size_t size, size_t *rsize) {
+        int compression = 0;
+
+#if HAVE_COMPRESSION
+        if (JOURNAL_FILE_COMPRESS(f) && size >= f->compress_threshold_bytes) {
+                compression = compress_blob(src, size, dst, size - 1, rsize);
+
+                if (compression > 0)
+                        log_debug("Compressed data object %zu -> %zu using %s", size, *rsize,
+                                  object_compressed_to_string(compression));
+        }
+#endif
+
+        return compression;
+}
+
 static int journal_file_append_data(
                 JournalFile *f,
                 const void *data, uint64_t size,
                 Object **ret, uint64_t *ret_offset) {
 
-        uint64_t hash, p, fp, osize;
-        Object *o, *fo;
-        int r, compression = 0;
-        const void *eq;
+        uint64_t hash, p, osize;
+        Object *o;
+        size_t rsize = 0;
+        int compression = 0;
+        int r;
 
         assert(f);
 
@@ -1670,10 +1686,6 @@ static int journal_file_append_data(
                 return 0;
         }
 
-        eq = memchr(data, '=', size);
-        if (!eq)
-                return -EINVAL;
-
         osize = offsetof(Object, data.payload) + size;
         r = journal_file_append_object(f, OBJECT_DATA, osize, &o, &p);
         if (r < 0)
@@ -1681,25 +1693,12 @@ static int journal_file_append_data(
 
         o->data.hash = htole64(hash);
 
-#if HAVE_COMPRESSION
-        if (JOURNAL_FILE_COMPRESS(f) && size >= f->compress_threshold_bytes) {
-                size_t rsize = 0;
-
-                compression = compress_blob(data, size, o->data.payload, size - 1, &rsize);
-
-                if (compression >= 0) {
-                        o->object.size = htole64(offsetof(Object, data.payload) + rsize);
-                        o->object.flags |= compression;
+        compression = maybe_compress_payload(f, o->data.payload, data, size, &rsize);
 
-                        log_debug("Compressed data object %"PRIu64" -> %zu using %s",
-                                  size, rsize, object_compressed_to_string(compression));
-                } else
-                        /* Compression didn't work, we don't really care why, let's continue without compression */
-                        compression = 0;
-        }
-#endif
-
-        if (compression == 0)
+        if (compression > 0) {
+                o->object.size = htole64(offsetof(Object, data.payload) + rsize);
+                o->object.flags |= compression;
+        } else
                 memcpy_safe(o->data.payload, data, size);
 
         r = journal_file_link_data(f, o, p, hash);
@@ -1718,15 +1717,6 @@ static int journal_file_append_data(
         if (r < 0)
                 return r;
 
-        /* Create field object ... */
-        r = journal_file_append_field(f, data, (uint8_t*) eq - (uint8_t*) data, &fo, &fp);
-        if (r < 0)
-                return r;
-
-        /* ... and link it in. */
-        o->data.next_field_offset = fo->field.head_data_offset;
-        fo->field.head_data_offset = le64toh(p);
-
         if (ret)
                 *ret = o;
 
@@ -1868,7 +1858,7 @@ int journal_file_data_payload(
                 ret_size);
 }
 
-static int journal_file_entry_item_next_compact(
+static int journal_file_entry_item_next_trie(
                 JournalFile *f,
                 Object *e,
                 uint64_t offset,
@@ -1883,14 +1873,7 @@ static int journal_file_entry_item_next_compact(
         uint64_t p;
         int r;
 
-        if (*i == UINT64_MAX)
-                return 0;
-
-        p = *i == 0 ? le64toh(e->entry.trie_offset) : *i;
-        if (p == 0)
-                return -EBADMSG;
-
-        for (; p != 0;) {
+        for (p = *i; p != 0;) {
                 Object *o;
                 uint64_t q;
 
@@ -1926,21 +1909,151 @@ static int journal_file_entry_item_next_compact(
                 if (ret_offset)
                         *ret_offset = q;
 
-                /* If we've iterated all trie nodes, set the iterator to UINT64_MAX to indicate this. We
-                * can't use zero as zero is reserved for starting iteration from the beginning. */
-                if (p == 0)
-                        p = UINT64_MAX;
+                *i = p;
+
+                return 1;
+        }
+
+        *i = p;
+
+        return 0;
+}
+
+static int journal_file_entry_item_next_inline(
+               JournalFile *f,
+               Object *e,
+               uint64_t offset,
+               uint64_t *i,
+               const char *field,
+               size_t field_length,
+               size_t data_threshold,
+               uint64_t *ret_offset,
+               void **ret_data,
+               size_t *ret_size) {
+
+        uint64_t p, sz;
+        int r;
+
+        sz = le64toh(READ_NOW(e->object.size));
+        if (sz < offsetof(Object, entry.payload))
+                return -EBADMSG;
+
+        for (p = *i; p < offset + sz;) {
+                uint8_t *d;
+                uint8_t flags;
+                uint64_t isz;
+
+                /* `i` stores the absolute offset of the current inline entry item. We convert it to an
+                 * offset relative to the `payload` field of the entry object and add it to the `payload`
+                 * field to get a pointer to the current inline entry item. */
+                d = e->entry.payload + p - offset - offsetof(Object, entry.payload);
+
+                p += sizeof(uint8_t) + sizeof(uint32_t);
+                if (p >= offset + sz)
+                        return -EBADMSG;
+
+                flags = *d++;
+                isz = unaligned_read_le32(d);
+                d += sizeof(uint32_t);
+
+                p += isz;
+                if (p > offset + sz)
+                        return -EBADMSG;
+
+                r = maybe_decompress_payload(
+                        f,
+                        d,
+                        isz,
+                        flags & OBJECT_COMPRESSION_MASK,
+                        field,
+                        field_length,
+                        data_threshold,
+                        ret_data,
+                        ret_size);
+                if (r == -EBADMSG) {
+                        log_debug("Inline entry item has bad payload, skipping over it.");
+                        continue;
+                }
+                if (r < 0)
+                        return r;
+                if (r == 0)
+                        continue;
+
+                if (ret_offset)
+                        *ret_offset = 0;
 
                 *i = p;
 
                 return 1;
         }
 
-        *i = UINT64_MAX;
+        *i = p;
 
         return 0;
 }
 
+static int journal_file_entry_item_next_compact(
+                JournalFile *f,
+                Object *e,
+                uint64_t offset,
+                uint64_t *i,
+                const char *field,
+                size_t field_length,
+                size_t data_threshold,
+                uint64_t *ret_offset,
+                void **ret_data,
+                size_t *ret_size) {
+
+        uint64_t p, sz;
+        int r;
+
+        if (*i == UINT64_MAX)
+                return 0;
+
+        sz = le64toh(READ_NOW(e->object.size));
+        if (sz < offsetof(Object, entry.payload))
+                return -EBADMSG;
+
+        p = *i == 0 ? le64toh(READ_NOW(e->entry.trie_offset)) : *i;
+
+        /* All of an entry's trie and data nodes are located before the entry object in the journal file. */
+        if (p > offset + sz)
+                return -EBADMSG;
+
+        /* If the iterator is located inside the entry object's payload, we're already iterating the inline
+         * entry items so we skip the trie node logic. */
+        if (p < offset) {
+                r = journal_file_entry_item_next_trie(
+                        f, e, offset, &p, field, field_length, data_threshold, ret_offset, ret_data, ret_size);
+                if (r < 0)
+                        return r;
+
+                /* If we've iterated all the trie nodes, set the iterator to the start of the inline entry
+                 * items. */
+                if (p == 0)
+                        p = offset + offsetof(Object, entry.payload);
+
+                if (r > 0) {
+                        *i = p;
+                        return r;
+                }
+        }
+
+        r = journal_file_entry_item_next_inline(
+                f, e, offset, &p, field, field_length, data_threshold, ret_offset, ret_data, ret_size);
+        if (r < 0)
+                return r;
+
+        /* If we finished with all the inline entry items, set the iterator to UINT64_MAX to indicate that
+         * we've finished iterating all the entry items. */
+        if (p == offset + sz)
+                p = UINT64_MAX;
+
+        *i = p;
+
+        return r;
+}
+
 static int journal_file_entry_item_next_non_compact(
                 JournalFile *f,
                 Object *e,
@@ -2004,7 +2117,8 @@ int journal_file_entry_item_next(
         /* Iterates over the entry items of the given entry. The output parameters return data about the Data
          * object pointed at by the next entry item if requested.
          *
-         * - If `ret_offset` is not NULL, it is set to the offset of the Data object
+         * - If `ret_offset` is not NULL, it is set to the offset of the Data object. If the data is stored
+         *   inline in the entry object, `ret_offset` is set to 0.
          * - If `ret_data` is not NULL, it is set to a pointer to the decompressed payload of the Data object
          * - If `ret_size` is not NULL, it is set to the size of the decompressed payload of the Data object
          *
@@ -2340,6 +2454,7 @@ static int journal_file_append_entry_internal(
                 const dual_timestamp *ts,
                 const sd_id128_t *boot_id,
                 const EntryItemEx items[], size_t n_items,
+                const struct iovec inlined[], size_t n_inlined,
                 uint64_t *seqnum,
                 Object **ret, uint64_t *ret_offset) {
         uint64_t np, osize, parent_offset = 0, xor_hash = 0;
@@ -2351,6 +2466,9 @@ static int journal_file_append_entry_internal(
         assert(items || n_items == 0);
         assert(ts);
 
+        if (!JOURNAL_HEADER_COMPACT(f->header))
+                assert(n_inlined == 0);
+
         for (uint64_t i = 0; i < n_items; i++)
                 xor_hash ^= items[i].xor_hash;
 
@@ -2382,18 +2500,49 @@ static int journal_file_append_entry_internal(
         }
 
         osize = JOURNAL_HEADER_COMPACT(f->header) ?
-                sizeof(EntryObject) :
+                offsetof(Object, entry.payload) :
                 offsetof(Object, entry.items) + (n_items * sizeof(EntryItem));
 
+        for (unsigned i = 0; i < n_inlined; i++) {
+                xor_hash ^= jenkins_hash64(inlined[i].iov_base, inlined[i].iov_len);
+                osize += sizeof(uint8_t) + sizeof(uint32_t) + inlined[i].iov_len;
+        }
+
         r = journal_file_append_object(f, OBJECT_ENTRY, osize, &o, &np);
         if (r < 0)
                 return r;
 
         o->entry.seqnum = htole64(journal_file_entry_seqnum(f, seqnum));
 
-        if (JOURNAL_HEADER_COMPACT(f->header))
+        if (JOURNAL_HEADER_COMPACT(f->header)) {
+                uint8_t *p = o->entry.payload;
                 o->entry.trie_offset = htole64(parent_offset);
-        else
+
+                for (unsigned i = 0; i < n_inlined; i++) {
+                        int compression = 0;
+                        size_t rsize;
+
+                        /* The format per inlined item is: flags (8-bit), size (32-bit), data (optionally
+                         * compressed). */
+
+                        compression = maybe_compress_payload(f, p + sizeof(uint8_t) + sizeof(uint32_t),
+                                                             inlined[i].iov_base, inlined[i].iov_len, &rsize);
+
+                        if (compression > 0) {
+                                *p++ = compression;
+                                unaligned_write_le32(p, rsize);
+                                p += sizeof(uint32_t) + rsize;
+                        } else {
+                                *p++ = 0;
+                                unaligned_write_le32(p, inlined[i].iov_len);
+                                p += sizeof(uint32_t);
+                                memcpy_safe(p, inlined[i].iov_base, inlined[i].iov_len);
+                                p += inlined[i].iov_len;
+                        }
+                }
+
+                o->object.size = htole64(offsetof(Object, entry.payload) + (p - o->entry.payload));
+        } else
                 for (size_t i = 0; i < n_items; i++)
                         o->entry.items[i] = (EntryItem){ .object_offset = htole64(items[i].object_offset),
                                                          .hash = htole64(items[i].hash) };
@@ -2523,6 +2672,21 @@ static size_t remove_duplicate_entry_items(EntryItemEx items[], size_t n) {
         return j;
 }
 
+static int journal_file_append_field_from_data(
+                JournalFile *f,
+                const char *data,
+                size_t size,
+                Object **ret,
+                uint64_t *ret_offset) {
+        const void *eq;
+
+        eq = memchr(data, '=', size);
+        if (!eq)
+                return -EINVAL;
+
+        return journal_file_append_field(f, data, (uint8_t*) eq - (uint8_t*) data, ret, ret_offset);
+}
+
 int journal_file_append_entry(
                 JournalFile *f,
                 const dual_timestamp *ts,
@@ -2532,6 +2696,8 @@ int journal_file_append_entry(
                 Object **ret, uint64_t *ret_offset) {
 
         EntryItemEx *items;
+        struct iovec *inlined;
+        size_t n_items = 0, n_inlined = 0;
         struct dual_timestamp _ts;
         int r;
 
@@ -2560,15 +2726,29 @@ int journal_file_append_entry(
 #endif
 
         items = newa(EntryItemEx, n_iovec);
+        inlined = newa(struct iovec, n_iovec);
 
         for (size_t i = 0; i < n_iovec; i++) {
                 uint64_t p;
-                Object *o;
+                Object *o, *fo;
+
+                r = journal_file_append_field_from_data(f, iovec[i].iov_base, iovec[i].iov_len, &fo, NULL);
+                if (r < 0)
+                        return r;
+
+                if (FLAGS_SET(fo->object.flags, FIELD_UNIQUE)) {
+                        inlined[n_inlined++] = iovec[i];
+                        continue;
+                }
 
                 r = journal_file_append_data(f, iovec[i].iov_base, iovec[i].iov_len, &o, &p);
                 if (r < 0)
                         return r;
 
+                /* Link data object into the field object. */
+                o->data.next_field_offset = fo->field.head_data_offset;
+                fo->field.head_data_offset = le64toh(p);
+
                 /* When calculating the XOR hash field, we need to take special care if the "keyed-hash"
                  * journal file flag is on. We use the XOR hash field to quickly determine the identity of a
                  * specific record, and give records with otherwise identical position (i.e. match in seqno,
@@ -2578,7 +2758,7 @@ int journal_file_append_entry(
                  * are completely identical (they include the XOR hash after all). For classic Jenkins-hash
                  * files things are easier, we can just take the value from the stored record directly. */
 
-                items[i] = (EntryItemEx){
+                items[n_items++] = (EntryItemEx){
                         .object_offset = p,
                         .hash = le64toh(o->data.hash),
                         .xor_hash = JOURNAL_HEADER_KEYED_HASH(f->header) ?
@@ -2589,10 +2769,11 @@ int journal_file_append_entry(
 
         /* Order by the position on disk, in order to improve seek
          * times for rotating media. */
-        typesafe_qsort(items, n_iovec, entry_item_cmp);
-        n_iovec = remove_duplicate_entry_items(items, n_iovec);
+        typesafe_qsort(items, n_items, entry_item_cmp);
+        n_items = remove_duplicate_entry_items(items, n_items);
 
-        r = journal_file_append_entry_internal(f, ts, boot_id, items, n_iovec, seqnum, ret, ret_offset);
+        r = journal_file_append_entry_internal(
+                f, ts, boot_id, items, n_items, inlined, n_inlined, seqnum, ret, ret_offset);
 
         /* If the memory mapping triggered a SIGBUS then we return an
          * IO error and ignore the error code passed down to us, since
@@ -3786,6 +3967,43 @@ static int journal_file_warn_btrfs(JournalFile *f) {
         return 1;
 }
 
+static int add_unique_fields(JournalFile *f) {
+        const char *e;
+        int r;
+
+        e = getenv("SYSTEMD_JOURNAL_UNIQUE_FIELDS");
+        if (!e)
+                e = "MESSAGE";
+
+        for (const char *p = e;;) {
+                Object *o;
+                _cleanup_free_ char *word = NULL;
+
+                r = extract_first_word(&p, &word, NULL, 0);
+                if (r == 0)
+                        return 0;
+                if (r == -ENOMEM)
+                        return log_oom();
+                if (r < 0) {
+                        log_debug_errno(r, "Failed to parse $SYSTEMD_JOURNALD_UNIQUE_FIELDS environment variable, ignoring: %m");
+                        return 0;
+                }
+
+                if (!journal_field_valid(word, strlen(word), true)) {
+                        log_debug("Invalid field name in $SYSTEMD_JOURNALD_UNIQUE_FIELDS environment variable, ignoring: %s", word);
+                        continue;
+                }
+
+                r = journal_file_append_field(f, word, strlen(word), &o, NULL);
+                if (r < 0)
+                        return r;
+
+                o->object.flags |= FIELD_UNIQUE;
+        }
+
+        return 0;
+}
+
 int journal_file_open(
                 int fd,
                 const char *fname,
@@ -4023,6 +4241,10 @@ int journal_file_open(
                         r = journal_file_setup_trie_hash_table(f);
                         if (r < 0)
                                 goto fail;
+
+                        r = add_unique_fields(f);
+                        if (r < 0)
+                                goto fail;
                 }
 
 #if HAVE_GCRYPT
@@ -4140,6 +4362,8 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
         const sd_id128_t *boot_id;
         dual_timestamp ts;
         EntryItemEx *items;
+        struct iovec *inlined;
+        size_t n_items = 0, n_inlined = 0;
         int r;
 
         assert(from);
@@ -4167,27 +4391,51 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
         }
 
         items = newa(EntryItemEx, n);
+        inlined = newa(struct iovec, n);
 
         for (uint64_t i = 0, j = 0;; j++) {
                 uint64_t h;
                 void *data;
                 size_t l;
-                Object *u;
+                Object *u, *fo;
 
                 r = journal_file_entry_item_next(from, o, p, &i, NULL, 0, 0, NULL, &data, &l);
                 if (r < 0)
-                        return r;
+                        goto finish;
                 if (r == 0)
                         break;
 
                 if (l == 0)
                         return -EBADMSG;
 
+                r = journal_file_append_field_from_data(to, data, l, &fo, NULL);
+                if (r < 0)
+                        goto finish;
+
+                if (FLAGS_SET(fo->object.flags, FIELD_UNIQUE)) {
+                        struct iovec iovec = {
+                                .iov_base = memdup(data, l),
+                                .iov_len = l,
+                        };
+
+                        if (!iovec.iov_base) {
+                                r = -ENOMEM;
+                                goto finish;
+                        }
+
+                        inlined[n_inlined++] = iovec;
+                        continue;
+                }
+
                 r = journal_file_append_data(to, data, l, &u, &h);
                 if (r < 0)
-                        return r;
+                        goto finish;
+
+                /* Link data object into the field object. */
+                u->data.next_field_offset = fo->field.head_data_offset;
+                fo->field.head_data_offset = le64toh(h);
 
-                items[j] = (EntryItemEx){
+                items[n_items++] = (EntryItemEx){
                         .object_offset = h,
                         .hash = le64toh(u->data.hash),
                         .xor_hash = JOURNAL_HEADER_KEYED_HASH(to->header) ? jenkins_hash64(data, l) :
@@ -4195,7 +4443,12 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
                 };
         }
 
-        r = journal_file_append_entry_internal(to, &ts, boot_id, items, n, NULL, NULL, NULL);
+        r = journal_file_append_entry_internal(
+                to, &ts, boot_id, items, n_items, inlined, n_inlined, NULL, NULL, NULL);
+
+finish:
+        for (size_t i = 0; i < n_inlined; i++)
+                free(inlined[i].iov_base);
 
         if (mmap_cache_fd_got_sigbus(to->cache_fd))
                 return -EIO;
diff --git a/src/libsystemd/sd-journal/journal-verify.c b/src/libsystemd/sd-journal/journal-verify.c
index 5028be9..c790345 100644
--- a/src/libsystemd/sd-journal/journal-verify.c
+++ b/src/libsystemd/sd-journal/journal-verify.c
@@ -240,19 +240,14 @@ static int journal_file_object_verify(JournalFile *f, uint64_t offset, Object *o
 
         case OBJECT_ENTRY:
                 if (JOURNAL_HEADER_COMPACT(f->header)) {
-                        if (le64toh(o->object.size) != sizeof(EntryObject)) {
+                        if (le64toh(o->object.size) < offsetof(Object, entry.payload)) {
                                 error(offset,
                                       "Bad entry size (<= %zu): %" PRIu64 ": %" PRIu64,
-                                      sizeof(EntryObject),
+                                      offsetof(Object, entry.payload),
                                       le64toh(o->object.size),
                                       offset);
                                 return -EBADMSG;
                         }
-
-                        if (o->entry.trie_offset == 0) {
-                                error(offset, "Bad entry trie offset (== 0): %" PRIu64, offset);
-                                return -EBADMSG;
-                        }
                 } else {
                         if ((le64toh(o->object.size) - offsetof(EntryObject, items)) % sizeof(EntryItem) != 0) {
                                 error(offset,
@@ -303,7 +298,7 @@ static int journal_file_object_verify(JournalFile *f, uint64_t offset, Object *o
                         if (r == 0)
                                 break;
 
-                        if (p == 0 || !VALID64(p)) {
+                        if (!VALID64(p)) {
                                 error(offset, "Invalid entry item (%"PRIu64" offset: "OFSfmt, i, p);
                                 return -EBADMSG;
                         }
@@ -777,7 +772,7 @@ static int verify_entry(
                         error_errno(p, r, "Invalid entry item of entry");
                         return r;
                 }
-                if (r == 0)
+                if (r == 0 || q == 0)
                         break;
 
                 if (!contains_uint64(cache_data_fd, n_data, q)) {

